require '_h2ph_pre.ph';

if(defined(&__arm__)) {
    require 'asm/hardware.ph';
}
undef(&KBD_REPORT_ERR) if defined(&KBD_REPORT_ERR);
unless(defined(&KBD_REPORT_UNKN)) {
    sub KBD_REPORT_UNKN () {	1;}
}
unless(defined(&KBD_REPORT_TIMEOUTS)) {
    sub KBD_REPORT_TIMEOUTS () {	1;}
}
undef(&KBD_IS_FOCUS_9000) if defined(&KBD_IS_FOCUS_9000);
undef(&INITIALIZE_MOUSE) if defined(&INITIALIZE_MOUSE);
unless(defined(&KBD_INIT_TIMEOUT)) {
    sub KBD_INIT_TIMEOUT () {	1000;}
}
unless(defined(&KBC_TIMEOUT)) {
    sub KBC_TIMEOUT () {	250;}
}
unless(defined(&KBD_TIMEOUT)) {
    sub KBD_TIMEOUT () {	1000;}
}
unless(defined(&KBD_STATUS_REG)) {
    sub KBD_STATUS_REG () {	0x64;}
}
unless(defined(&KBD_CNTL_REG)) {
    sub KBD_CNTL_REG () {	0x64;}
}
unless(defined(&KBD_DATA_REG)) {
    sub KBD_DATA_REG () {	0x60;}
}
if(defined(&HAS_IOMD)) {
    eval 'sub KBD_CCMD_KBD_ENABLE () {0x8;}' unless defined(&KBD_CCMD_KBD_ENABLE);
    eval 'sub KBD_CCMD_KBD_DISABLE () {0x;}' unless defined(&KBD_CCMD_KBD_DISABLE);
} else {
    eval 'sub KBD_CCMD_READ_MODE () {0x20;}' unless defined(&KBD_CCMD_READ_MODE);
    eval 'sub KBD_CCMD_WRITE_MODE () {0x60;}' unless defined(&KBD_CCMD_WRITE_MODE);
    eval 'sub KBD_CCMD_GET_VERSION () {0xa1;}' unless defined(&KBD_CCMD_GET_VERSION);
    eval 'sub KBD_CCMD_MOUSE_DISABLE () {0xa7;}' unless defined(&KBD_CCMD_MOUSE_DISABLE);
    eval 'sub KBD_CCMD_MOUSE_ENABLE () {0xa8;}' unless defined(&KBD_CCMD_MOUSE_ENABLE);
    eval 'sub KBD_CCMD_TEST_MOUSE () {0xa9;}' unless defined(&KBD_CCMD_TEST_MOUSE);
    eval 'sub KBD_CCMD_SELF_TEST () {0xaa;}' unless defined(&KBD_CCMD_SELF_TEST);
    eval 'sub KBD_CCMD_KBD_TEST () {0xab;}' unless defined(&KBD_CCMD_KBD_TEST);
    eval 'sub KBD_CCMD_KBD_DISABLE () {0xad;}' unless defined(&KBD_CCMD_KBD_DISABLE);
    eval 'sub KBD_CCMD_KBD_ENABLE () {0xae;}' unless defined(&KBD_CCMD_KBD_ENABLE);
    eval 'sub KBD_CCMD_WRITE_AUX_OBUF () {0xd3;}' unless defined(&KBD_CCMD_WRITE_AUX_OBUF);
    eval 'sub KBD_CCMD_WRITE_MOUSE () {0xd4;}' unless defined(&KBD_CCMD_WRITE_MOUSE);
}
unless(defined(&KBD_CMD_SET_LEDS)) {
    sub KBD_CMD_SET_LEDS () {	0xed;}
}
unless(defined(&KBD_CMD_SET_RATE)) {
    sub KBD_CMD_SET_RATE () {	0xf3;}
}
unless(defined(&KBD_CMD_ENABLE)) {
    sub KBD_CMD_ENABLE () {	0xf4;}
}
unless(defined(&KBD_CMD_DISABLE)) {
    sub KBD_CMD_DISABLE () {	0xf5;}
}
unless(defined(&KBD_CMD_RESET)) {
    sub KBD_CMD_RESET () {	0xff;}
}
unless(defined(&KBD_REPLY_POR)) {
    sub KBD_REPLY_POR () {	0xaa;}
}
unless(defined(&KBD_REPLY_ACK)) {
    sub KBD_REPLY_ACK () {	0xfa;}
}
unless(defined(&KBD_REPLY_RESEND)) {
    sub KBD_REPLY_RESEND () {	0xfe;}
}
if(defined(&HAS_IOMD)) {
    eval 'sub KBD_STAT_OBF () {0x20;}' unless defined(&KBD_STAT_OBF);
    eval 'sub KBD_STAT_IBF () {0x;}' unless defined(&KBD_STAT_IBF);
    eval 'sub KBD_STAT_IBE () {0x80;}' unless defined(&KBD_STAT_IBE);
    eval 'sub KBD_STAT_GTO () {0x;}' unless defined(&KBD_STAT_GTO);
    eval 'sub KBD_STAT_PERR () {0x;}' unless defined(&KBD_STAT_PERR);
    eval 'sub KBD_STAT_MOUSE_OBF () {0x;}' unless defined(&KBD_STAT_MOUSE_OBF);
} else {
    eval 'sub KBD_STAT_OBF () {0x1;}' unless defined(&KBD_STAT_OBF);
    eval 'sub KBD_STAT_IBF () {0x2;}' unless defined(&KBD_STAT_IBF);
    eval 'sub KBD_STAT_SELFTEST () {0x4;}' unless defined(&KBD_STAT_SELFTEST);
    eval 'sub KBD_STAT_CMD () {0x8;}' unless defined(&KBD_STAT_CMD);
    eval 'sub KBD_STAT_UNLOCKED () {0x10;}' unless defined(&KBD_STAT_UNLOCKED);
    eval 'sub KBD_STAT_MOUSE_OBF () {0x20;}' unless defined(&KBD_STAT_MOUSE_OBF);
    eval 'sub KBD_STAT_GTO () {0x40;}' unless defined(&KBD_STAT_GTO);
    eval 'sub KBD_STAT_PERR () {0x80;}' unless defined(&KBD_STAT_PERR);
    eval 'sub AUX_STAT_OBF () {( &KBD_STAT_OBF |  &KBD_STAT_MOUSE_OBF);}' unless defined(&AUX_STAT_OBF);
}
unless(defined(&KBD_MODE_KBD_INT)) {
    sub KBD_MODE_KBD_INT () {	0x1;}
}
unless(defined(&KBD_MODE_MOUSE_INT)) {
    sub KBD_MODE_MOUSE_INT () {	0x2;}
}
unless(defined(&KBD_MODE_SYS)) {
    sub KBD_MODE_SYS () {	0x4;}
}
unless(defined(&KBD_MODE_NO_KEYLOCK)) {
    sub KBD_MODE_NO_KEYLOCK () {	0x8;}
}
unless(defined(&KBD_MODE_DISABLE_KBD)) {
    sub KBD_MODE_DISABLE_KBD () {	0x10;}
}
unless(defined(&KBD_MODE_DISABLE_MOUSE)) {
    sub KBD_MODE_DISABLE_MOUSE () {	0x20;}
}
unless(defined(&KBD_MODE_KCC)) {
    sub KBD_MODE_KCC () {	0x40;}
}
unless(defined(&KBD_MODE_RFU)) {
    sub KBD_MODE_RFU () {	0x80;}
}
unless(defined(&AUX_SET_RES)) {
    sub AUX_SET_RES () {	0xe8;}
}
unless(defined(&AUX_SET_SCALE11)) {
    sub AUX_SET_SCALE11 () {	0xe6;}
}
unless(defined(&AUX_SET_SCALE21)) {
    sub AUX_SET_SCALE21 () {	0xe7;}
}
unless(defined(&AUX_GET_SCALE)) {
    sub AUX_GET_SCALE () {	0xe9;}
}
unless(defined(&AUX_SET_STREAM)) {
    sub AUX_SET_STREAM () {	0xea;}
}
unless(defined(&AUX_SET_SAMPLE)) {
    sub AUX_SET_SAMPLE () {	0xf3;}
}
unless(defined(&AUX_ENABLE_DEV)) {
    sub AUX_ENABLE_DEV () {	0xf4;}
}
unless(defined(&AUX_DISABLE_DEV)) {
    sub AUX_DISABLE_DEV () {	0xf5;}
}
unless(defined(&AUX_RESET)) {
    sub AUX_RESET () {	0xff;}
}
unless(defined(&AUX_ACK)) {
    sub AUX_ACK () {	0xfa;}
}
unless(defined(&AUX_BUF_SIZE)) {
    sub AUX_BUF_SIZE () {	2048;}
}
1;
